require "ostruct"

require "namesplit/version"
require "namesplit/simple_split"
require "namesplit/clean"
require "namesplit/titleize"
require "namesplit/first_names"
require "namesplit/first_names_list"

module Namesplit
  # Public : Cette méthode organise progressivement le split du nom et du
  # prénom. Les différentes solutions sont testées une à une jusqu'à ce que
  # l'une d'entre elle fonctionne.
  #
  def self.split(full_name)
    @result = OpenStruct.new(quality: 0)
    return @result if full_name.nil?
    clean(full_name)

    with_first_names
    with_uppercasing if @result.first_names.nil?
    with_space if @result.first_names.nil?

    clean_output
  end
end
