# Pour les cas de Split les plus simples.
#
module Namesplit
  private

  # Private : Dans le cas où seuls deux éléments composent le string et qu'aucun
  # nom ou prénom n'est détecté parmi l'un ou l'autre.
  #
  def self.with_space
    words = @full_name.split(" ")
    @result.first_names = words[0]
    words.delete(words[0])

    @result.last_name = words.join(" ")
    @result.quality = 0.3
  end

  # Private : En fonction des majuscules ou non, on détecte le nom de la
  # personne. Afin d'éviter les problèmes avec les "-" ou les accents majuscules
  # "À" on effectue quelques pourcentage.
  #
  def self.with_uppercasing
    words = @full_name.split(" ")
    return if uppercase_percentage > 0.95

    last_name = ""
    last_index = 0
    words.each.with_index do |word, index|
      result = word.gsub(/[^A-Z]/, "").size / word.size.to_f

      next if result < 0.7
      next if last_name != "" && last_index != index - 1
      last_name << " " + word
      last_index = index
    end

    return if last_name == ""
    last_name.strip! && last_name.split(" ").each { |w| words.delete(w) }
    @result.last_name = last_name
    @result.first_names = words.join(" ")
    @result.quality = 0.8
  end

  # Private : Renvoie le pourcentage de lettre dans la phrase en majuscules.
  #
  def self.uppercase_percentage
    name = @full_name.gsub(/[^A-Za-z]/, "")
    name.gsub(/[^A-Z]/, "").size / name.size.to_f
  end
end
